'use strict';

/* Filters */

angular.module('licenseServerApp.filters', []).
  filter('interpolate', ['version', function(version) {
    return function(text) {
      return String(text).replace(/\%VERSION\%/mg, version);
    }
  }])
.filter('licenseFilter', function () {
    return function (items, filterText, dateflag, validateDate) {
        if (angular.isUndefined(filterText)) {
            return items;
        } else {
            if (filterText.trim() == null) {
                return items;
            }

            if (dateflag) {
                var isValidDate = validateDate(filterText);
                if (isValidDate) {
                    var filtered = [];
                    var searchDate = new Date(filterText)
                    var licenseDate;
                    angular.forEach(items, function (item) {
                        licenseDate = new Date(item.LastSessionStart);
                        if (licenseDate.valueOf() == searchDate.valueOf()) {
                            filtered.push(item);
                        }
                    });
                    return filtered;
                } else {
                    return items;
                }
            }
            else {
                var filtered = [];
                var user;
                var searchString = filterText.toLowerCase();
                angular.forEach(items, function (item) {
                    user = item.UserId.toLowerCase();
                    if (user.indexOf(searchString) > -1) {
                        filtered.push(item);
                    }
                });
                return filtered;
            }
        }
    };
});